/*=======================================*
 *                                       *
 *         IP1kC - ICOM PCR1000          *
 *                                       *
 *---------------------------------------*
 *                                       *
 *   Compiled with GCC / PRC-Tools 2.0   *
 *         using Palm OS SDK 4.0         *
 *                                       *
 *---------------------------------------*
 *                                       *
 *           JJR / 5 July 2004           *
 *                                       *
 *---------------------------------------*
 *                                       *
 *     E-mail: jjintokyo@hotmail.com     *
 *                                       *
 *=======================================*/

#include	<PalmOS.h>
#include	"IP1kC.h"

static	FormPtr		gFormP;
static	FieldPtr	gFieldP;
static	UInt16		gSerialPortID;
static	Boolean		gSupportsColor=true;
static	Boolean		gRadioIsOn=false;
static	Boolean		gScanIsOn=false;
static	Boolean		gSignalAutoUpdateIsOn=false;
static	Boolean		gAboutIP1kCFormIsShown=false;
static	UInt32		gLastResetTime=0;
static	UInt32		gLastUpdateTime=0;
static	Int32		gFrequency=81300000;
static	Int32		gFrequencyAdjust=100000;
static	Char		gModeSetting[3]="06\0";
static	Char		gFilterSetting[3]="04\0";
static	UInt16		gMode=WFM;
static	UInt16		gFilter=K230;
static	Int16		gTuningStep=18;
static	Boolean		gAFC=false;
static	Boolean		gAGC=false;
static	Boolean		gATT=false;
static	Boolean		gNB=false;
static	Int16		gVolume=100;
static	Int16		gSquelch=90;
static	Int16		gIfShift=128;
static	Int16		gVolumeSaved=0;
static	Int16		gSquelchSaved=0;
static	Boolean		gPCR1000=true;
static	Boolean		gScanMemory=false;
static	Int16		gLoopBack=6;
static	Int16		gPauseScan=5;
static	Int32		gScanStartFrequency=0;
static	Int32		gScanStopFrequency=0;
static	Boolean		gScanGoesUp=true;
static	Boolean		gHoldScan=false;
static	FontID		gOriginalFont;
static	Char		gAnimationCharacter;
static	Int16		gAnimationPosX=64;
static	Int16		gAnimationPosY=40;
static	Boolean		gAnimationUpDownLeftRight[4]={false, false, false, true};
static	Int16		gSerialDataIndex=0;
static	Char		gSerialData[400][35];
static	Int16		gNumberOfBands=31;
static	Int32		gBand[31]={100000, 150000, 531000, 2300000, 3200000, 3850000, 4750000, 5900000, 7100000,
				   9400000, 11600000, 13570000, 15030000, 17480000, 18900000, 21450000, 25670000,
				   27000000, 51000000, 76000000, 88000000, 108000000, 144000000, 253000000, 380000000,
				   430000000, 450000000, 850000000, 900000000, 1240000000, 1300000000};
static	Char		gBandDescription[31][20]={"[Start Frequency]", "[LW]", "[MW]", "[SW - 120 Meters]",
						  "[SW - 90 Meters]", "[SW - 75 Meters]", "[SW - 60 Meters]",
						  "[SW - 49 Meters]", "[SW - 41 Meters]", "[SW - 31 Meters]",
						  "[SW - 25 Meters]", "[SW - 22 Meters]", "[SW - 19 Meters]",
						  "[SW - 16 Meters]", "[SW - 15 Meters]", "[SW - 13 Meters]",
						  "[SW - 11 Meters]", "[CB]", "[HAM VHF Low]", "[FM - Japan]",
						  "[FM - World]", "[Air Band]", "[HAM VHF High]", "[Cordless Handset]",
						  "[Cordless Base]", "[HAM UHF Low]", "[450 MHz Band]",
						  "[850 MHz Band]", "[900 MHz Band]", "[HAM UHF High]",
						  "[Stop Frequency]"};
static	Int16		gNumberOfMemories=0;
static	Int16		gMemoryIndex=-1;
static	Int32		gMemory[99];
static	Char		gMemoryDescription[99][26];
static	UInt16		gMemoryMemoRecordNumber[99];
static	UInt16		gCurrentMemoRecordNumber=0;
static	Boolean		gShowMemoryCounter=false;

typedef struct {
	Int32		pFrequency;
	UInt16		pMode;
	UInt16		pFilter;
	Int16		pTuningStep;
	Boolean		pAFC;
	Boolean		pAGC;
	Boolean		pATT;
	Boolean		pNB;
	Int16		pVolume;
	Int16		pSquelch;
	Int16		pIfShift;
	Int16		pVolumeSaved;
	Int16		pSquelchSaved;
	Boolean		pPCR1000;
	Boolean		pScanMemory;
	Int16		pLoopBack;
	Int16		pPauseScan;
} applicationPreferencesType;

static	Err	StartApplication(void);
static	void	StopApplication(void);
static	void	EventLoop(void);
static	Boolean	ButtonsEventHandler(EventPtr event);
static	Boolean	ApplicationEventHandler(EventPtr event);
static	Boolean	MainFormEventHandler(EventPtr event);
static	Boolean	MainMenuEventHandler(UInt16 menuID);
static	Boolean	SignalStrengthFormEventHandler(EventPtr event);
static	Boolean	SetupScanFormEventHandler(EventPtr event);
static	Boolean	ViewSerialDataFormEventHandler(EventPtr event);
static	void	ViewSerialDataListDrawItem(Int16 itemNum, RectanglePtr bounds, Char **data);
static	Boolean	AboutIP1kCFormEventHandler(EventPtr event);
static	void*	GetObjectPtr(UInt16 objectID);
static	Int32	GetTimeOutValue(void);
static	Boolean	MenuIsVisible(void);
static	void	InitializeApplication(FormPtr formP);
static	void	SwitchRadioOnOff(void);
static	void	SetFrequencyUpDown(UInt16 controlID);
static	void	SetMode(UInt16 controlID);
static	void	SetFilter(UInt16 controlID);
static	void	SetTuningStep(Int16 listItem);
static	void	SetAFC(void);
static	void	SetAGC(void);
static	void	SetATT(void);
static	void	SetNB(void);
static	void	SetVolume(void);
static	void	SetSquelch(void);
static	void	SetIfShift(void);
static	void	SetVolumeOnOff(void);
static	void	SetSquelchOnOff(void);
static	void	SetIfShiftCenter(void);
static	void	TuneIn(void);
static	Err	OpenCommPort(void);
static	Err	CloseCommPort(void);
static	Err	SendCommandToRadio(Char* command);
static	Char*	ReceiveDataFromRadio(void);
static	void	DisplayCommError(Char* message, Err commError);
static	void	ChangeFrequency(void);
static	void	GetSignalStrength(void);
static	void	StartStopScan(void);
static	void	DoScan(void);
static	void	DoAnimation(void);
static	void	SetBandUpDown(Boolean plus);
static	void	SetMemoryUpDown(Boolean plus);
static	void	GuessModeFilterTuningStep(void);
static	void	SetModeFilterTuningStep(UInt16 xMode, UInt16 xFilter, Int16 xTuningStep);
static	void	DisplayFrequencyDescription(Char* description);
static	void	ReadMemoryFromMemoPad(void);
static	void	ShowMemoryCounter(void);
static	UInt32	StrHToI(const Char* string);
static	void	ExitApplication(void);

UInt32 PilotMain(UInt16 launchCode, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err	error=0;

	if (launchCode==sysAppLaunchCmdNormalLaunch) {
		if ((error=StartApplication())==0) {
			EventLoop();
			StopApplication();
		}
	}
	return error;
}

static Err StartApplication(void)
{
	applicationPreferencesType	prefs;
	UInt16				prefsSize=sizeof(applicationPreferencesType);

	if (PrefGetAppPreferences('JJip', 0, &prefs, &prefsSize, true)!=noPreferenceFound) {
		gFrequency=prefs.pFrequency;
		gMode=prefs.pMode;
		gFilter=prefs.pFilter;
		gTuningStep=prefs.pTuningStep;
		gAFC=prefs.pAFC;
		gAGC=prefs.pAGC;
		gATT=prefs.pATT;
		gNB=prefs.pNB;
		gVolume=prefs.pVolume;
		gSquelch=prefs.pSquelch;
		gIfShift=prefs.pIfShift;
		gVolumeSaved=prefs.pVolumeSaved;
		gSquelchSaved=prefs.pSquelchSaved;
		gPCR1000=prefs.pPCR1000;
		gScanMemory=prefs.pScanMemory;
		gLoopBack=prefs.pLoopBack;
		gPauseScan=prefs.pPauseScan;
	}
	ReadMemoryFromMemoPad();
	WinScreenMode(winScreenModeGetSupportsColor, NULL, NULL, NULL, &gSupportsColor);
	FrmGotoForm(MainForm);
	return 0;
}

static void StopApplication(void)
{
	applicationPreferencesType	prefs;

	if (gRadioIsOn) {		SendCommandToRadio("H100");
					CloseCommPort();
	}

	FrmCloseAllForms();

	prefs.pFrequency=gFrequency;
	prefs.pMode=gMode;
	prefs.pFilter=gFilter;
	prefs.pTuningStep=gTuningStep;
	prefs.pAFC=gAFC;
	prefs.pAGC=gAGC;
	prefs.pATT=gATT;
	prefs.pNB=gNB;
	prefs.pVolume=gVolume;
	prefs.pSquelch=gSquelch;
	prefs.pIfShift=gIfShift;
	prefs.pVolumeSaved=gVolumeSaved;
	prefs.pSquelchSaved=gSquelchSaved;
	prefs.pPCR1000=gPCR1000;
	prefs.pScanMemory=gScanMemory;
	prefs.pLoopBack=gLoopBack;
	prefs.pPauseScan=gPauseScan;
	PrefSetAppPreferences('JJip', 0, 0, &prefs, sizeof(prefs), true);
}

static void EventLoop(void)
{
	EventType	event;
	UInt16		error;

	do {
		if (TimGetSeconds()-gLastResetTime>55) {		EvtResetAutoOffTimer();
									gLastResetTime=TimGetSeconds();
		}

		if (gScanIsOn)			DoScan();
		if (gSignalAutoUpdateIsOn)	GetSignalStrength();
		if (gAboutIP1kCFormIsShown)	DoAnimation();

		EvtGetEvent(&event, GetTimeOutValue());

		if (!ButtonsEventHandler(&event))
			if (!ApplicationEventHandler(&event))
				if (!MenuHandleEvent(0, &event, &error))
					if (!SysHandleEvent(&event))
						FrmDispatchEvent(&event);
	}
	while (event.eType!=appStopEvent);
}

static Boolean ButtonsEventHandler(EventPtr event)
{
	Boolean		handled=false;
	Boolean		okToDo;
	Int16		value, min, max, pageSize;

	if (event->eType==keyDownEvent) {
		if ((FrmGetActiveFormID()==MainForm) && (!MenuIsVisible()))	okToDo=true;
		else								okToDo=false;

		switch (event->data.keyDown.chr) {
			case pageUpChr:
				if (okToDo) {
						if (!gScanMemory) {		SetFrequencyUpDown(Up);
										TuneIn();
						}
						else				SetMemoryUpDown(1);
						handled=true;
				}
				break;
			case pageDownChr:
				if (okToDo) {
						if (!gScanMemory) {		SetFrequencyUpDown(Dn);
										TuneIn();
						}
						else				SetMemoryUpDown(0);
						handled=true;
				}
				break;
			case hard1Chr:
				if (okToDo) {	SclGetScrollBar(GetObjectPtr(Volume), &value, &min, &max, &pageSize);
						value-=5;
						if (value<min) value=min;
						SclSetScrollBar(GetObjectPtr(Volume), value, min, max, pageSize);
						SetVolume();
				}
				handled=true;
				break;
			case hard2Chr:
				if (okToDo) {	SclGetScrollBar(GetObjectPtr(Volume), &value, &min, &max, &pageSize);
						value+=5;
						if (value>max) value=max;
						SclSetScrollBar(GetObjectPtr(Volume), value, min, max, pageSize);
						SetVolume();
				}
				handled=true;
				break;
			case hard3Chr:
				if (okToDo) {	SclGetScrollBar(GetObjectPtr(Squelch), &value, &min, &max, &pageSize);
						value-=5;
						if (value<min) value=min;
						SclSetScrollBar(GetObjectPtr(Squelch), value, min, max, pageSize);
						SetSquelch();
				}
				handled=true;
				break;
			case hard4Chr:
				if (okToDo) {	SclGetScrollBar(GetObjectPtr(Squelch), &value, &min, &max, &pageSize);
						value+=5;
						if (value>max) value=max;
						SclSetScrollBar(GetObjectPtr(Squelch), value, min, max, pageSize);
						SetSquelch();
				}
				handled=true;
				break;
			case hardCradleChr:
				if (okToDo)	StartStopScan();
				handled=true;
				break;
			case calcChr:
				handled=true;
				break;
			case findChr:
				handled=true;
				break;
			default: break;
		}
	}
	return handled;
}

static Boolean ApplicationEventHandler(EventPtr event)
{
	Boolean		handled=false;
	UInt16		formID;
	FormPtr		formP;

	if (event->eType==frmLoadEvent) {
		formID=event->data.frmLoad.formID;
		formP=FrmInitForm(formID);
		FrmSetActiveForm(formP);
		if	(formID==MainForm)		FrmSetEventHandler(formP, MainFormEventHandler);
		else if	(formID==SignalStrengthForm)	FrmSetEventHandler(formP, SignalStrengthFormEventHandler);
		else if	(formID==SetupScanForm)		FrmSetEventHandler(formP, SetupScanFormEventHandler);
		else if	(formID==ViewSerialDataForm)	FrmSetEventHandler(formP, ViewSerialDataFormEventHandler);
		else if	(formID==AboutIP1kCForm)	FrmSetEventHandler(formP, AboutIP1kCFormEventHandler);
		handled=true;
	}
	return handled;
}

static Boolean MainFormEventHandler(EventPtr event)
{
	Boolean		handled=false;
	UInt16		controlID;
	UInt16		scrollBarID;
	UInt16		listID;
	Int16		listItem;
	UInt16		fieldID;
	UInt16		menuID;
	Boolean		penDown;
	Int16		posX, posY;

	switch (event->eType) {
		case frmOpenEvent:
			gFormP=FrmGetActiveForm();
			InitializeApplication(gFormP);
			FrmDrawForm(gFormP);
			TuneIn();
			handled=true;
			break;
		case frmCloseEvent:
			FrmEraseForm(gFormP);
			FrmDeleteForm(gFormP);
			gFormP=0;
			handled=true;
			break;
		case ctlSelectEvent:
			controlID=event->data.ctlSelect.controlID;

			if (controlID==RadioOnOff) {					SwitchRadioOnOff();
											handled=true;
											break;
			}
			if ((controlID==Up) || (controlID==Dn)) {			SetFrequencyUpDown(controlID);
											TuneIn();
											handled=true;
											break;
			}
			if ((controlID==AM) || (controlID==FM)  || (controlID==WFM) ||
			   (controlID==USB) || (controlID==LSB) || (controlID==CW)) {	SetMode(controlID);
											TuneIn();
											handled=true;
											break;
			}
			if ((controlID==K2) || (controlID==K6) || (controlID==K15) ||
			   (controlID==K50) || (controlID==K230)) {			SetFilter(controlID);
											TuneIn();
											handled=true;
											break;
			}
			if (controlID==AFC) {						SetAFC();
											handled=true;
											break;
			}
			if (controlID==AGC) {						SetAGC();
											handled=true;
											break;
			}
			if (controlID==ATT) {						SetATT();
											handled=true;
											break;
			}
			if (controlID==NB) {						SetNB();
											handled=true;
											break;
			}

			break;
		case ctlRepeatEvent:
			controlID=event->data.ctlRepeat.controlID;

			if ((controlID==Up) || (controlID==Dn)) {			SetFrequencyUpDown(controlID);
											TuneIn();
			}

			break;
		case sclEnterEvent:
			scrollBarID=event->data.sclEnter.scrollBarID;

			if	(scrollBarID==Volume)					SetVolume();
			else if	(scrollBarID==Squelch)					SetSquelch();
			else if	(scrollBarID==IfShift)					SetIfShift();

			break;
		case sclRepeatEvent:
			scrollBarID=event->data.sclRepeat.scrollBarID;

			if	(scrollBarID==Volume)					SetVolume();
			else if	(scrollBarID==Squelch)					SetSquelch();
			else if	(scrollBarID==IfShift)					SetIfShift();

			break;
		case popSelectEvent:
			listID=event->data.popSelect.listID;
			listItem=event->data.popSelect.selection;

			if (listID==TuningStepList)					SetTuningStep(listItem);

			break;
		case fldChangedEvent:
			fieldID=event->data.fldChanged.fieldID;

			if (fieldID==FrequencyDisplay)					ChangeFrequency();

			break;
		case fldEnterEvent:
			fieldID=event->data.fldEnter.fieldID;

			if (fieldID==FrequencyDisplay)					ChangeFrequency();

			break;
		case menuEvent:
			menuID=event->data.menu.itemID;
			handled=MainMenuEventHandler(menuID);

			break;
		case penDownEvent:
			PenGetPoint(&posX, &posY, &penDown);

			if	((posX>=85  && posX<=101) && (posY>=149 && posY<=160))	SetBandUpDown(0);
			else if	((posX>=85  && posX<=101) && (posY>=132 && posY<=143))	SetBandUpDown(1);
			else if	((posX>=107 && posX<=123) && (posY>=149 && posY<=160))	SetMemoryUpDown(0);
			else if	((posX>=107 && posX<=123) && (posY>=132 && posY<=143))	SetMemoryUpDown(1);
			else if	((posX>=15  && posX<=65)  && (posY>=95  && posY<=105))	SetVolumeOnOff();
			else if	((posX>=15  && posX<=65)  && (posY>=117 && posY<=127))	SetSquelchOnOff();
			else if	((posX>=15  && posX<=65)  && (posY>=139 && posY<=149))	SetIfShiftCenter();
			else if	((posX>=88  && posX<=120) && (posY>=96  && posY<=128))	StartStopScan();
			else if	((posX>=0   && posX<=49)  && (posY>=20  && posY<=48))	FrmPopupForm(SignalStrengthForm);
			else if	((posX>=120 && posX<=136) && (posY>=0   && posY<=15))	FrmPopupForm(SetupScanForm);
			else if	((posX>=137 && posX<=160) && (posY>=0   && posY<=15))	FrmPopupForm(AboutIP1kCForm);
			else if	((posX>=0   && posX<=128) && (posY>=49  && posY<=60))	ShowMemoryCounter();

			break;
		case nilEvent:
			break;
		default: break;
	}
	return handled;
}

static Boolean MainMenuEventHandler(UInt16 menuID)
{
	Boolean		handled=false;

	switch (menuID) {
		case MainOptionsGetSignalStrength:
			FrmPopupForm(SignalStrengthForm);
			handled=true;
			break;
		case MainOptionsViewSerialData:
			FrmPopupForm(ViewSerialDataForm);
			handled=true;
			break;
		case MainOptionsInputFrequency:
			FrmSetFocus(gFormP, FrmGetObjectIndex(gFormP, FrequencyDisplay));
			SysKeyboardDialog(kbdNumbersAndPunc);
			handled=true;
			break;
		case MainOptionsAboutIP1kC:
			FrmPopupForm(AboutIP1kCForm);
			handled=true;
			break;
		case MainOptionsExitIP1kC:
			ExitApplication();
			handled=true;
			break;
		case MainScanSetupScan:
			FrmPopupForm(SetupScanForm);
			handled=true;
			break;
		case MainScanStartStopScan:
			StartStopScan();
			handled=true;
			break;
		case MainEditUndo:
			FldUndo(gFieldP);
			handled=true;
			break;
		case MainEditCut:
			FldCut(gFieldP);
			handled=true;
			break;
		case MainEditCopy:
			FldCopy(gFieldP);
			handled=true;
			break;
		case MainEditPaste:
			FldPaste(gFieldP);
			handled=true;
			break;
		case MainEditSelectAll:
			FldSetSelection(gFieldP, 0, FldGetTextLength(gFieldP));
			handled=true;
			break;
		case MainEditKeyboard:
			SysKeyboardDialog(kbdDefault);
			handled=true;
			break;
		case MainEditGraffitiHelp:
			SysGraffitiReferenceDialog(referenceDefault);
			handled=true;
			break;
		default: break;
	}
	return handled;
}

static Boolean SignalStrengthFormEventHandler(EventPtr event)
{
	Boolean		handled=false;
	FormPtr		formP;
	UInt16		controlID;

	switch (event->eType) {
		case frmOpenEvent:
			formP=FrmGetActiveForm();
			CtlSetValue(GetObjectPtr(Auto), 0);
			FrmDrawForm(formP);
			gSignalAutoUpdateIsOn=false;
			GetSignalStrength();
			handled=true;
			break;
		case ctlSelectEvent:
			controlID=event->data.ctlSelect.controlID;

			if (controlID==Close) {
				gSignalAutoUpdateIsOn=false;
				formP=0;
				FrmReturnToForm(0);
				handled=true;
				break;
			}
			if (controlID==Update) {
				GetSignalStrength();
				handled=true;
				break;
			}
			if (controlID==Auto) {
				if (gRadioIsOn) {
					if (CtlGetValue(GetObjectPtr(Auto)))	gSignalAutoUpdateIsOn=true;
					else					gSignalAutoUpdateIsOn=false;
				}
				handled=true;
				break;
			}
		case nilEvent:
			break;
		default: break;
	}
	return handled;
}

static Boolean SetupScanFormEventHandler(EventPtr event)
{
	Boolean		handled=false;
	FormPtr		formP;
	UInt16		controlID;

	switch (event->eType) {
		case frmOpenEvent:
			formP=FrmGetActiveForm();
			if (gPCR1000)		FrmSetControlGroupSelection(formP, 1, PCR1000);
			else			FrmSetControlGroupSelection(formP, 1, PCR100);
			if (gScanMemory)	FrmSetControlGroupSelection(formP, 2, ScanMemory);
			else			FrmSetControlGroupSelection(formP, 2, ScanFrequency);
			LstSetSelection(GetObjectPtr(LoopBackList), gLoopBack);
			LstSetSelection(GetObjectPtr(PauseScanList), gPauseScan);
			LstMakeItemVisible(GetObjectPtr(LoopBackList), gLoopBack);
			LstMakeItemVisible(GetObjectPtr(PauseScanList), gPauseScan);
			CtlSetLabel(GetObjectPtr(LoopBack), LstGetSelectionText(GetObjectPtr(LoopBackList), gLoopBack));
			CtlSetLabel(GetObjectPtr(PauseScan), LstGetSelectionText(GetObjectPtr(PauseScanList), gPauseScan));
			FrmDrawForm(formP);
			handled=true;
			break;
		case ctlSelectEvent:
			controlID=event->data.ctlSelect.controlID;

			if (controlID==OK) {
				if (CtlGetValue(GetObjectPtr(PCR1000)))			gPCR1000=true;
				else							gPCR1000=false;
				if (CtlGetValue(GetObjectPtr(ScanMemory)))		gScanMemory=true;
				else							gScanMemory=false;
				gLoopBack=LstGetSelection(GetObjectPtr(LoopBackList));
				gPauseScan=LstGetSelection(GetObjectPtr(PauseScanList));
				formP=0;
				FrmReturnToForm(0);
				handled=true;
				break;
			}
			if (controlID==Cancel) {
				formP=0;
				FrmReturnToForm(0);
				handled=true;
				break;
			}
			if (controlID==Default) {
				FrmSetControlGroupSelection(FrmGetActiveForm(), 1, PCR1000);
				FrmSetControlGroupSelection(FrmGetActiveForm(), 2, ScanFrequency);
				LstSetSelection(GetObjectPtr(LoopBackList), 6);
				LstSetSelection(GetObjectPtr(PauseScanList), 5);
				LstMakeItemVisible(GetObjectPtr(LoopBackList), 6);
				LstMakeItemVisible(GetObjectPtr(PauseScanList), 5);
				CtlSetLabel(GetObjectPtr(LoopBack), LstGetSelectionText(GetObjectPtr(LoopBackList), 6));
				CtlSetLabel(GetObjectPtr(PauseScan), LstGetSelectionText(GetObjectPtr(PauseScanList), 5));
				handled=true;
				break;
			}
		case nilEvent:
			break;
		default: break;
	}
	return handled;
}

static Boolean ViewSerialDataFormEventHandler(EventPtr event)
{
	Boolean		handled=false;
	FormPtr		formP;
	UInt16		controlID;

	switch (event->eType) {
		case frmOpenEvent:
			formP=FrmGetActiveForm();
			LstSetDrawFunction(GetObjectPtr(ViewSerialDataList), ViewSerialDataListDrawItem);
			LstSetListChoices(GetObjectPtr(ViewSerialDataList), NULL, gSerialDataIndex);
			FrmDrawForm(formP);
			handled=true;
			break;
		case ctlSelectEvent:
			controlID=event->data.ctlSelect.controlID;

			if (controlID==OK2) {
				formP=0;
				FrmReturnToForm(0);
				handled=true;
				break;
			}
			if (controlID==Top) {
				LstSetSelection(GetObjectPtr(ViewSerialDataList), 0);
				LstMakeItemVisible(GetObjectPtr(ViewSerialDataList), 0);
				handled=true;
				break;
			}
			if (controlID==Bottom) {
				LstSetSelection(GetObjectPtr(ViewSerialDataList), gSerialDataIndex-1);
				LstMakeItemVisible(GetObjectPtr(ViewSerialDataList), gSerialDataIndex-1);
				handled=true;
				break;
			}
			if (controlID==Clear) {
				for (gSerialDataIndex=0; gSerialDataIndex<400; gSerialDataIndex++)
					gSerialData[gSerialDataIndex][0]=chrNull;
				gSerialDataIndex=0;
				LstSetListChoices(GetObjectPtr(ViewSerialDataList), NULL, gSerialDataIndex);
				FrmDrawForm(FrmGetActiveForm());
				handled=true;
				break;
			}
		case nilEvent:
			break;
		default: break;
	}
	return handled;
}

static void ViewSerialDataListDrawItem(Int16 itemNum, RectanglePtr bounds, Char **data)
{
	Char			text1[4]="000\0";
	Char			text2[4]="000\0";
	Int16			len, i;
	IndexedColorType	redIndex=125, greenIndex=210, blackIndex=255;

	StrIToA(text1, itemNum);
	len=StrLen(text1);
	for (i=0; i<len; i++) {
		text2[3-len+i]=text1[i];
	}
	WinDrawChars(text2, StrLen(text2), bounds->topLeft.x, bounds->topLeft.y);
	if (gSupportsColor) {
		if (gSerialData[itemNum][1]=='>')	WinSetTextColor(redIndex);
		if (gSerialData[itemNum][0]=='<')	WinSetTextColor(greenIndex);
	}
	WinDrawChars(gSerialData[itemNum], StrLen(gSerialData[itemNum]), bounds->topLeft.x+20, bounds->topLeft.y);
	if (gSupportsColor)	WinSetTextColor(blackIndex);
}

static Boolean AboutIP1kCFormEventHandler(EventPtr event)
{
	Boolean			handled=false;
	FormPtr			formP;
	UInt16			controlID;
	IndexedColorType	blueIndex=95;

	switch (event->eType) {
		case frmOpenEvent:
			formP=FrmGetActiveForm();
			FrmDrawForm(formP);
			if (gSupportsColor)	WinSetForeColor(blueIndex);
			WinDrawLine(62, 12, 62, 67);
			WinDrawLine(0, 67, 62, 67);
			WinDrawLine(117, 120, 117, 155);
			WinDrawLine(117, 120, 155, 120);
			WinDrawLine(62, 39, 149, 39);
			WinDrawLine(149, 39, 149, 120);
			WinDrawLine(62, 56, 132, 56);
			WinDrawLine(132, 56, 132, 120);
			gAboutIP1kCFormIsShown=true;
			gOriginalFont=FntSetFont(largeBoldFont);
			gAnimationPosX=64;
			gAnimationPosY=40;
			gAnimationUpDownLeftRight[0]=false;
			gAnimationUpDownLeftRight[1]=false;
			gAnimationUpDownLeftRight[2]=false;
			gAnimationUpDownLeftRight[3]=true;
			SysTaskDelay(sysTicksPerSecond);
			handled=true;
			break;
		case ctlSelectEvent:
			controlID=event->data.ctlSelect.controlID;

			if (controlID==Thanks) {
				gAboutIP1kCFormIsShown=false;
				FntSetFont(gOriginalFont);
				formP=0;
				FrmReturnToForm(0);
				handled=true;
				break;
			}
		case nilEvent:
			break;
		default: break;
	}
	return handled;
}

static void* GetObjectPtr(UInt16 objectID)
{
	return (FrmGetObjectPtr(FrmGetActiveForm(), FrmGetObjectIndex(FrmGetActiveForm(), objectID)));
}

static Int32 GetTimeOutValue(void)
{
	if	(gScanIsOn)			return 0;
	else if	(gSignalAutoUpdateIsOn)		return 100;
	else if	(gAboutIP1kCFormIsShown)	return 2;
	else					return (sysTicksPerSecond*55);
}

static Boolean MenuIsVisible(void)
{
	MenuBarType	*menuBarTypeP=MenuGetActiveMenu();

	if ((menuBarTypeP) && (menuBarTypeP->attr.visible))	return true;
	else							return false;
}

static void InitializeApplication(FormPtr formP)
{
	Char	text[4]="000\0";

	SetModeFilterTuningStep(gMode, gFilter, gTuningStep);

	CtlSetValue(GetObjectPtr(AFC), gAFC);
	CtlSetValue(GetObjectPtr(AGC), gAGC);
	CtlSetValue(GetObjectPtr(ATT), gATT);
	CtlSetValue(GetObjectPtr(NB),  gNB);

	SclSetScrollBar(GetObjectPtr(Volume),  gVolume,  0, 255, 1);
	SclSetScrollBar(GetObjectPtr(Squelch), gSquelch, 0, 255, 1);
	SclSetScrollBar(GetObjectPtr(IfShift), gIfShift, 0, 255, 1);

	StrIToA(text, gVolume);
	FrmCopyLabel(formP, VolumeLabel,  text);
	StrIToA(text, gSquelch);
	FrmCopyLabel(formP, SquelchLabel, text);
	StrIToA(text, gIfShift);
	FrmCopyLabel(formP, IfShiftLabel, text);

	CtlSetLabel(GetObjectPtr(RadioOnOff), "On");

	FrmHideObject(formP, FrmGetObjectIndex(formP, IP1kC));
	FrmHideObject(formP, FrmGetObjectIndex(formP, SCAN));
	FrmHideObject(formP, FrmGetObjectIndex(formP, WAIT));

	gFieldP=GetObjectPtr(FrequencyDisplay);
	StrPrintF(&gAnimationCharacter, "%c", 164);
}

static void SwitchRadioOnOff(void)
{
	Err	commError;

	if (gRadioIsOn) {
		SendCommandToRadio("H100");
		commError=CloseCommPort();
		if (commError) return;
		CtlSetLabel(GetObjectPtr(RadioOnOff), "On");
		FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, IP1kC));
		FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
		FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
		gRadioIsOn=false;
		gScanIsOn=false;
		gSignalAutoUpdateIsOn=false;
	}
	else {
		commError=OpenCommPort();
		if (commError) return;
		CtlSetLabel(GetObjectPtr(RadioOnOff), "Off");
		FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
		FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
		FrmShowObject(gFormP, FrmGetObjectIndex(gFormP, IP1kC));
		gRadioIsOn=true;
		commError=SendCommandToRadio("H101");
		if (commError) return;
		commError=SendCommandToRadio("G300");
		if (commError) return;
		TuneIn();
		SetVolume();
		SetSquelch();
		SetIfShift();
		SetAFC();
		SetAGC();
		SetATT();
		SetNB();
	}
}

static void SetFrequencyUpDown(UInt16 controlID)
{
	if	(controlID==Up) {		gFrequency+=gFrequencyAdjust;
						if (gFrequency>1300000000)	gFrequency=100000;
						if (gScanIsOn)			gScanGoesUp=true;
	}
	else if	(controlID==Dn) {		gFrequency-=gFrequencyAdjust;
						if (gFrequency<100000)		gFrequency=1300000000;
						if (gScanIsOn)			gScanGoesUp=false;
	}
}

static void SetMode(UInt16 controlID)
{
	gMode=controlID;

	if	(gMode==AM)			StrCopy(gModeSetting, "02");
	else if	(gMode==FM)			StrCopy(gModeSetting, "05");
	else if	(gMode==WFM)			StrCopy(gModeSetting, "06");
	else if	(gMode==USB)			StrCopy(gModeSetting, "01");
	else if	(gMode==LSB)			StrCopy(gModeSetting, "00");
	else if	(gMode==CW)			StrCopy(gModeSetting, "03");
}

static void SetFilter(UInt16 controlID)
{
	gFilter=controlID;

	if	(gFilter==K2)			StrCopy(gFilterSetting, "00");
	else if	(gFilter==K6)			StrCopy(gFilterSetting, "01");
	else if	(gFilter==K15)			StrCopy(gFilterSetting, "02");
	else if	(gFilter==K50)			StrCopy(gFilterSetting, "03");
	else if	(gFilter==K230)			StrCopy(gFilterSetting, "04");
}

static void SetTuningStep(Int16 listItem)
{
	gTuningStep=listItem;

	if	(gTuningStep==0)		gFrequencyAdjust=1;
	else if	(gTuningStep==1)		gFrequencyAdjust=10;
	else if	(gTuningStep==2)		gFrequencyAdjust=20;
	else if	(gTuningStep==3)		gFrequencyAdjust=50;
	else if	(gTuningStep==4)		gFrequencyAdjust=100;
	else if	(gTuningStep==5)		gFrequencyAdjust=500;
	else if	(gTuningStep==6)		gFrequencyAdjust=1000;
	else if	(gTuningStep==7)		gFrequencyAdjust=2500;
	else if	(gTuningStep==8)		gFrequencyAdjust=5000;
	else if	(gTuningStep==9)		gFrequencyAdjust=6250;
	else if	(gTuningStep==10)		gFrequencyAdjust=8330;
	else if	(gTuningStep==11)		gFrequencyAdjust=9000;
	else if	(gTuningStep==12)		gFrequencyAdjust=10000;
	else if	(gTuningStep==13)		gFrequencyAdjust=12500;
	else if	(gTuningStep==14)		gFrequencyAdjust=20000;
	else if	(gTuningStep==15)		gFrequencyAdjust=25000;
	else if	(gTuningStep==16)		gFrequencyAdjust=30000;
	else if	(gTuningStep==17)		gFrequencyAdjust=50000;
	else if	(gTuningStep==18)		gFrequencyAdjust=100000;
	else if	(gTuningStep==19)		gFrequencyAdjust=500000;
	else if	(gTuningStep==20)		gFrequencyAdjust=1000000;
	else if	(gTuningStep==21)		gFrequencyAdjust=10000000;
	else if	(gTuningStep==22)		gFrequencyAdjust=100000000;
}

static void SetAFC(void)
{
	gAFC=CtlGetValue(GetObjectPtr(AFC));

	if (gAFC)				SendCommandToRadio("J5001");
	else					SendCommandToRadio("J5000");
}

static void SetAGC(void)
{
	gAGC=CtlGetValue(GetObjectPtr(AGC));

	if (gAGC)				SendCommandToRadio("J4501");
	else					SendCommandToRadio("J4500");
}

static void SetATT(void)
{
	gATT=CtlGetValue(GetObjectPtr(ATT));

	if (gATT)				SendCommandToRadio("J4701");
	else					SendCommandToRadio("J4700");
}

static void SetNB(void)
{
	gNB=CtlGetValue(GetObjectPtr(NB));

	if (gNB)				SendCommandToRadio("J4601");
	else					SendCommandToRadio("J4600");
}

static void SetVolume(void)
{
	Int16	value, min, max, pageSize;
	Char	text[4]="000\0";
	Char	hex[9]="00000000\0";
	Char	volumeCommand[6]="J4000\0";

	SclGetScrollBar(GetObjectPtr(Volume), &value, &min, &max, &pageSize);
	gVolume=value;
	StrIToA(text, gVolume);
	FrmCopyLabel(gFormP, VolumeLabel, text);
	StrIToH(hex, gVolume);
	volumeCommand[3]=hex[6];
	volumeCommand[4]=hex[7];

	SendCommandToRadio(volumeCommand);
}

static void SetSquelch(void)
{
	Int16	value, min, max, pageSize;
	Char	text[4]="000\0";
	Char	hex[9]="00000000\0";
	Char	squelchCommand[6]="J4100\0";

	SclGetScrollBar(GetObjectPtr(Squelch), &value, &min, &max, &pageSize);
	gSquelch=value;
	StrIToA(text, gSquelch);
	FrmCopyLabel(gFormP, SquelchLabel, text);
	StrIToH(hex, gSquelch);
	squelchCommand[3]=hex[6];
	squelchCommand[4]=hex[7];

	SendCommandToRadio(squelchCommand);
}

static void SetIfShift(void)
{
	Int16	value, min, max, pageSize;
	Char	text[4]="000\0";
	Char	hex[9]="00000000\0";
	Char	ifShiftCommand[6]="J4300\0";

	SclGetScrollBar(GetObjectPtr(IfShift), &value, &min, &max, &pageSize);
	gIfShift=value;
	StrIToA(text, gIfShift);
	FrmCopyLabel(gFormP, IfShiftLabel, text);
	StrIToH(hex, gIfShift);
	ifShiftCommand[3]=hex[6];
	ifShiftCommand[4]=hex[7];

	SendCommandToRadio(ifShiftCommand);
}

static void SetVolumeOnOff(void)
{
	Int16	value, min, max, pageSize;

	SclGetScrollBar(GetObjectPtr(Volume), &value, &min, &max, &pageSize);
	if (value==0)	value=gVolumeSaved;
	else {		gVolumeSaved=value;
			value=0;
	}
	SclSetScrollBar(GetObjectPtr(Volume), value, min, max, pageSize);

	SetVolume();
}

static void SetSquelchOnOff(void)
{
	Int16	value, min, max, pageSize;

	SclGetScrollBar(GetObjectPtr(Squelch), &value, &min, &max, &pageSize);
	if (value==0)	value=gSquelchSaved;
	else {		gSquelchSaved=value;
			value=0;
	}
	SclSetScrollBar(GetObjectPtr(Squelch), value, min, max, pageSize);

	SetSquelch();
}

static void SetIfShiftCenter(void)
{
	Int16	value, min, max, pageSize;

	SclGetScrollBar(GetObjectPtr(IfShift), &value, &min, &max, &pageSize);
	value=128;
	SclSetScrollBar(GetObjectPtr(IfShift), value, min, max, pageSize);

	SetIfShift();
}

static void TuneIn(void)
{
	MemHandle	oldHandle, newHandle;
	Char*		string;
	Char		frequencyComplete[11]="0000000000\0";
	Char		frequencyFormated[13]="   0.000.000\0";
	Char		tuneInCommand[19]="K00000000000000000\0";
	Int16		len, i, j;

	StrIToA(frequencyComplete, gFrequency);
	len=StrLen(frequencyComplete);
	for (i=len-1, j=11; i>=0; i--, j--) {
		if ((j==4) || (j==8)) j--;
		frequencyFormated[j]=frequencyComplete[i];
	}
	oldHandle=FldGetTextHandle(gFieldP);
	newHandle=MemHandleNew(32);
	string=MemHandleLock(newHandle);
	StrCopy(string, frequencyFormated);
	MemHandleUnlock(newHandle);
	FldSetTextHandle(gFieldP, newHandle);
	FldDrawField(gFieldP);
	FldSetSelection(gFieldP, 0, FldGetTextLength(gFieldP));
	if (oldHandle) MemHandleFree(oldHandle);
	DisplayFrequencyDescription("");
	gShowMemoryCounter=false;
	for (i=0; i<len; i++) {
		tuneInCommand[(10-len)+2+i]=frequencyComplete[i];
	}
	tuneInCommand[12]=gModeSetting[0];
	tuneInCommand[13]=gModeSetting[1];
	tuneInCommand[14]=gFilterSetting[0];
	tuneInCommand[15]=gFilterSetting[1];

	SendCommandToRadio(tuneInCommand);
}

static Err OpenCommPort(void)
{
	Err	commError=0;
	Int32	baudRate=9600;
	Int16	baudRateSize=sizeof(baudRate);
	UInt32	flags=srmSettingsFlagBitsPerChar8 |
		      srmSettingsFlagStopBits1    |
		      srmSettingsFlagRTSAutoM     |
		      srmSettingsFlagCTSAutoM;
	UInt16	flagsSize=sizeof(flags);

	commError=SrmOpen(serPortCradlePort, 9600, &gSerialPortID);
	if (commError) {
		DisplayCommError("SrmOpen()\nCannot open the serial port...\n\ncommError=", commError);
	}
	else {
		SrmControl(gSerialPortID, srmCtlSetBaudRate, &baudRate, &baudRateSize);
		SrmControl(gSerialPortID, srmCtlSetFlags, &flags, &flagsSize);
		SrmReceiveFlush(gSerialPortID, 0);
		SrmSendFlush(gSerialPortID);
	}
	return commError;
}

static Err CloseCommPort(void)
{
	Err	commError=0;

	SrmSendWait(gSerialPortID);
	commError=SrmClose(gSerialPortID);
	if (commError) {
		DisplayCommError("SrmClose()\nCannot close the serial port...\n\ncommError=", commError);
	}
	return commError;
}

static Err SendCommandToRadio(Char* command)
{
	Err	commError=0;
	Char	dataToSend[32];
	Int16	len, i;

	if (gRadioIsOn) {
		len=StrLen(command);
		StrCopy(dataToSend, command);
		dataToSend[len]=chrCarriageReturn;
		dataToSend[len+1]=chrLineFeed;
		dataToSend[len+2]=chrNull;
		SrmSend(gSerialPortID, dataToSend, StrLen(dataToSend), &commError);
		if (commError) {
			DisplayCommError(
			"SrmSend()\nCommunication with radio failed... Please check cables and power.\n\ncommError=",
			commError);
		}
		if (gSerialDataIndex==400)	gSerialDataIndex=0;
		gSerialData[gSerialDataIndex][0]='-';
		gSerialData[gSerialDataIndex][1]='>';
		gSerialData[gSerialDataIndex][2]=' ';
		len=StrLen(dataToSend);
		for (i=0; i<len; i++)
			gSerialData[gSerialDataIndex][i+3]=dataToSend[i];
		gSerialData[gSerialDataIndex][i+3]=chrNull;
		gSerialDataIndex++;
	}
	return commError;
}

static Char* ReceiveDataFromRadio(void)
{
	Err	commError;
	Char	dataReceived[32];
	UInt32	numberOfBytesAvailable;
	UInt32	numberOfBytesProvided;
	Char*	dataP;
	Int16	len, i;

	if (gRadioIsOn) {
		SrmReceiveCheck(gSerialPortID, &numberOfBytesAvailable);
		if (numberOfBytesAvailable>32)	numberOfBytesAvailable=32;
		numberOfBytesProvided=SrmReceive(gSerialPortID, &dataReceived, numberOfBytesAvailable, 0, &commError);
		if (commError) {
			DisplayCommError(
			"SrmReceive()\nCommunication with radio failed... Please check cables and power.\n\ncommError=",
			commError);
		}
		dataReceived[numberOfBytesProvided]=chrNull;
		dataP=MemPtrNew(40);
		StrCopy(dataP, dataReceived);
		if (gSerialDataIndex==400)	gSerialDataIndex=0;
		gSerialData[gSerialDataIndex][0]='<';
		gSerialData[gSerialDataIndex][1]='-';
		gSerialData[gSerialDataIndex][2]=' ';
		len=StrLen(dataReceived);
		for (i=0; i<len; i++)
			gSerialData[gSerialDataIndex][i+3]=dataReceived[i];
		gSerialData[gSerialDataIndex][i+3]=chrNull;
		gSerialDataIndex++;
	}
	return dataP;
}

static void DisplayCommError(Char* message, Err commError)
{
	Char	text[20];

	StrIToA(text, commError);
	FrmCustomAlert(SystemError, message, text, NULL);
}

static void ChangeFrequency(void)
{
	UInt16		textLen;
	Char*		textPtr;
	Boolean		decimalPointFound=false;
	Char		tempStringComplete[13]="000000000000\0";
	Char		tempStringInteger[13]="000000000000\0";
	Char		tempStringDecimal[13]="000000000000\0";
	Int32		tempFrequencyComplete;
	Int32		tempFrequencyInteger;
	Int32		tempFrequencyDecimal;
	Int16		len, i, j, k;

	textLen=FldGetTextLength(gFieldP);
	if (textLen>0) {
		textPtr=FldGetTextPtr(gFieldP);
		StrCopy(tempStringComplete, textPtr);
		len=StrLen(tempStringComplete);
		for (i=0, j=0, k=0; i<len; i++) {
			if (tempStringComplete[i]!=' ') {
				if (tempStringComplete[i]=='.') {
					decimalPointFound=true;
				}
				else {
					if (decimalPointFound)	tempStringDecimal[k++]=tempStringComplete[i];
					else			tempStringInteger[j++]=tempStringComplete[i];
				}
			}
		}
		tempStringInteger[j]=chrNull;
		tempStringDecimal[k]=chrNull;
		tempFrequencyInteger=0;
		tempFrequencyDecimal=0;
		if (StrLen(tempStringInteger)>0) {
			tempFrequencyInteger=StrAToI(tempStringInteger);
			if (tempFrequencyInteger>1300) {	tempFrequencyInteger=0;
								tempStringDecimal[0]=chrNull;
			}
			else					tempFrequencyInteger*=1000000;
		}
		if (StrLen(tempStringDecimal)>0) {
			tempFrequencyDecimal=StrAToI(tempStringDecimal);
			if	(StrLen(tempStringDecimal)==1)	tempFrequencyDecimal*=100000;
			else if	(StrLen(tempStringDecimal)==2)	tempFrequencyDecimal*=10000;
			else if	(StrLen(tempStringDecimal)==3)	tempFrequencyDecimal*=1000;
			else if	(StrLen(tempStringDecimal)==4)	tempFrequencyDecimal*=100;
			else if	(StrLen(tempStringDecimal)==5)	tempFrequencyDecimal*=10;
		}
		tempFrequencyComplete=tempFrequencyInteger+tempFrequencyDecimal;
		if ((tempFrequencyComplete>=100000) && (tempFrequencyComplete<=1300000000)) {
			if (gFrequency!=tempFrequencyComplete) {
								gFrequency=tempFrequencyComplete;
								GuessModeFilterTuningStep();
			}
		}
	}
	TuneIn();
}

static void GetSignalStrength(void)
{
	Err			commError;
	Char*			dataP;
	Char*			foundP;
	Int16			i;
	Char			signalHex[3]="00\0";
	UInt16			signalInt;
	RectangleType		rectangle={4, 15, 150, 14};
	IndexedColorType	lightSilverIndex=224, lightPinkIndex=9, pinkIndex=17, purpleIndex=35, blackIndex=255;
	Int16			bar;

	if (gRadioIsOn) {
		if (gSignalAutoUpdateIsOn) {
			if (TimGetSeconds()-gLastUpdateTime<1)	return;
			gLastUpdateTime=TimGetSeconds();
		}
		SrmReceiveFlush(gSerialPortID, 0);
		commError=SendCommandToRadio("I1?");
		if (commError) {			gSignalAutoUpdateIsOn=false;
							return;
		}
		SysTaskDelay(sysTicksPerSecond/10);
		dataP=ReceiveDataFromRadio();
		foundP=StrStr(dataP, "I1");
		if (dataP) MemPtrFree(dataP);
		if (foundP) {
			foundP+=2;
			StrNCopy(signalHex, foundP, 2);
			signalInt=StrHToI(signalHex);
			if ((signalInt>=0) && (signalInt<=255)) {
				WinEraseRectangle(&rectangle, 0);
				for (i=0, bar=0; i<signalInt/2+22; i++, bar++) {
					if (gSupportsColor) {
						if	(i==0)		WinSetForeColor(lightPinkIndex);
						else if	(i==41)		WinSetForeColor(pinkIndex);
						else if	(i==83)		WinSetForeColor(purpleIndex);
						else if	(i==119)	WinSetForeColor(blackIndex);
					}
					if (bar!=5)	WinDrawLine(4+i, 15, 4+i, 28);
					else		bar=-1;
				}
			}
		}
	}
	else {
		if (gSupportsColor)	WinSetForeColor(lightSilverIndex);
		for (i=0, bar=0; i<149; i++, bar++) {
			if (bar!=5)	WinDrawLine(4+i, 15, 4+i, 28);
			else		bar=-1;
		}
	}
}

static void StartStopScan(void)
{
	if (gRadioIsOn) {
		if (gScanIsOn) {
			gScanIsOn=false;
			gHoldScan=false;
			FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
			FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
			FrmShowObject(gFormP, FrmGetObjectIndex(gFormP, IP1kC));
		}
		else {
			if ((gScanMemory) && (gNumberOfMemories==0)) return;
			gScanIsOn=true;
			gHoldScan=false;
			gScanGoesUp=true;
			FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, IP1kC));
			FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
			FrmShowObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
			if ((!gScanMemory) && (gLoopBack!=0)) {
				gScanStartFrequency=gFrequency;
				gScanStopFrequency=gFrequency;
				if	(gLoopBack==1)			gScanStopFrequency+=100000;
				else if	(gLoopBack==2)			gScanStopFrequency+=200000;
				else if	(gLoopBack==3)			gScanStopFrequency+=500000;
				else if	(gLoopBack==4)			gScanStopFrequency+=750000;
				else if	(gLoopBack==5)			gScanStopFrequency+=1000000;
				else if	(gLoopBack==6)			gScanStopFrequency+=1500000;
				else if	(gLoopBack==7)			gScanStopFrequency+=2000000;
				else if	(gLoopBack==8)			gScanStopFrequency+=5000000;
				else if	(gLoopBack==9)			gScanStopFrequency+=10000000;
				else if (gLoopBack==10)			gScanStopFrequency+=20000000;
				else if	(gLoopBack==11)			gScanStopFrequency+=50000000;
				else if	(gLoopBack==12)			gScanStopFrequency+=100000000;
				if (gScanStopFrequency>1300000000)	gScanStopFrequency=1300000000;
			}
		}
	}
}

static void DoScan(void)
{
	Err		commError;
	Char*		dataP;
	Char*		foundP;
	Char		code;
	Int16		waitUntil, loop;
	EventType	event;

	if ((gRadioIsOn) && (gScanIsOn) && (FrmGetActiveFormID()==MainForm) && (!MenuIsVisible())) {
		if (!gHoldScan) {
			if (!gScanMemory) {
				if (gScanGoesUp) {
					SetFrequencyUpDown(Up);
					TuneIn();
					if ((gLoopBack!=0) && (gFrequency>=gScanStopFrequency))
						gFrequency=gScanStartFrequency;
				}
				else {
					SetFrequencyUpDown(Dn);
					TuneIn();
					if ((gLoopBack!=0) && (gFrequency<=gScanStartFrequency))
						gFrequency=gScanStopFrequency;
				}
			}
			else {
				if (gScanGoesUp)	SetMemoryUpDown(1);
				else			SetMemoryUpDown(0);
			}
		}
		SysTaskDelay(sysTicksPerSecond/10);
		SrmReceiveFlush(gSerialPortID, 0);
		commError=SendCommandToRadio("I0?");
		if (commError) {			StartStopScan();
							return;
		}
		SysTaskDelay(sysTicksPerSecond/10);
		dataP=ReceiveDataFromRadio();
		foundP=StrStr(dataP, "I0");
		if (dataP) MemPtrFree(dataP);
		if (foundP) {
			foundP+=3;
			StrNCopy(&code, foundP, 1);
			if (((gPCR1000) && (code=='7')) || ((!gPCR1000) && (code=='3'))) {
				FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
				FrmShowObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
				if (gPauseScan!=0) {
					waitUntil=0;
					if	(gPauseScan==1)		waitUntil=1;
					else if	(gPauseScan==2)		waitUntil=2;
					else if	(gPauseScan==3)		waitUntil=3;
					else if	(gPauseScan==4)		waitUntil=5;
					else if	(gPauseScan==5)		waitUntil=10;
					else if	(gPauseScan==6)		waitUntil=15;
					else if	(gPauseScan==7)		waitUntil=20;
					else if	(gPauseScan==8)		waitUntil=30;
					else if	(gPauseScan==9)		waitUntil=45;
					else if	(gPauseScan==10)	waitUntil=60;
					else if	(gPauseScan==11) {
						gHoldScan=true;
						SysTaskDelay(sysTicksPerSecond*2);
						return;
					}
					else if (gPauseScan==12) {
						StartStopScan();
						return;
					}
					loop=0;
					do {
						loop++;
						SysTaskDelay(sysTicksPerSecond);
						EvtGetEvent(&event, 0);
						FrmDispatchEvent(&event);
						if (!gScanIsOn)		return;
						if (!gRadioIsOn)	return;
					}
					while (loop<waitUntil);
				}
				FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
				FrmShowObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
			}
			else {
				if (gHoldScan) {	gHoldScan=false;
							FrmHideObject(gFormP, FrmGetObjectIndex(gFormP, WAIT));
							FrmShowObject(gFormP, FrmGetObjectIndex(gFormP, SCAN));
				}
			}
		}
	}
}

static void DoAnimation(void)
{
	IndexedColorType	redIndex=125, greenIndex=210;

	WinEraseChars(&gAnimationCharacter, 1, gAnimationPosX, gAnimationPosY);

	if (gAnimationUpDownLeftRight[0]) {
		if (gSupportsColor)		WinSetTextColor(greenIndex);
		gAnimationPosX=137;
		gAnimationPosY--;
		if (gAnimationPosY<=40) {	gAnimationUpDownLeftRight[0]=false;
						gAnimationUpDownLeftRight[2]=true;
		}
	}
	else if (gAnimationUpDownLeftRight[1]) {
		if (gSupportsColor)		WinSetTextColor(redIndex);
		gAnimationPosX=137;
		gAnimationPosY++;
		if (gAnimationPosY>=105) {	gAnimationUpDownLeftRight[1]=false;
						gAnimationUpDownLeftRight[0]=true;
		}
	}
	else if (gAnimationUpDownLeftRight[2]) {
		if (gSupportsColor)		WinSetTextColor(greenIndex);
		gAnimationPosX--;
		gAnimationPosY=40;
		if (gAnimationPosX<=64) {	gAnimationUpDownLeftRight[2]=false;
						gAnimationUpDownLeftRight[3]=true;
		}
	}
	else if (gAnimationUpDownLeftRight[3]) {
		if (gSupportsColor)		WinSetTextColor(redIndex);
		gAnimationPosX++;
		gAnimationPosY=40;
		if (gAnimationPosX>=137) {	gAnimationUpDownLeftRight[3]=false;
						gAnimationUpDownLeftRight[1]=true;
		}
	}
	WinDrawChar(gAnimationCharacter, gAnimationPosX, gAnimationPosY);
}

static void SetBandUpDown(Boolean plus)
{
	Int16	i;

	for (i=0; i<gNumberOfBands; i++)
		if (gBand[i]>gFrequency) break;

	if (plus) {
		if (i==gNumberOfBands) i=0;
	}
	else {
		i--;
		if (gBand[i]==gFrequency) i--;
		if (i<0) i=gNumberOfBands-1;
	}

	if ((gBand[i]>=100000) && (gBand[i]<=1300000000)) {	gFrequency=gBand[i];
								GuessModeFilterTuningStep();
								TuneIn();
								DisplayFrequencyDescription(gBandDescription[i]);
								gShowMemoryCounter=false;
	}
}

static void SetMemoryUpDown(Boolean plus)
{
	if (gNumberOfMemories!=0) {
		do {
			if (plus) {	gMemoryIndex++;
					if (gMemoryIndex>=gNumberOfMemories)	gMemoryIndex=0;
					if (gScanIsOn)				gScanGoesUp=true;
			}
			else {		gMemoryIndex--;
					if (gMemoryIndex<0)			gMemoryIndex=gNumberOfMemories-1;
					if (gScanIsOn)				gScanGoesUp=false;
			}

			if ((gScanIsOn) && (gMemoryMemoRecordNumber[gMemoryIndex]!=gCurrentMemoRecordNumber)) continue;

			if ((gMemory[gMemoryIndex]>=100000) && (gMemory[gMemoryIndex]<=1300000000)) {
				gFrequency=gMemory[gMemoryIndex];
				gCurrentMemoRecordNumber=gMemoryMemoRecordNumber[gMemoryIndex];
				GuessModeFilterTuningStep();
				TuneIn();
				DisplayFrequencyDescription(gMemoryDescription[gMemoryIndex]);
				gShowMemoryCounter=true;
				break;
			}
		}
		while (0==0);
	}
}

static void GuessModeFilterTuningStep(void)
{
	if	((gFrequency>=100000)    && (gFrequency<150000))	SetModeFilterTuningStep(AM,  K6,   12);
	else if	((gFrequency>=150000)    && (gFrequency<531000))	SetModeFilterTuningStep(AM,  K6,    6);
	else if	((gFrequency>=531000)    && (gFrequency<1620000))	SetModeFilterTuningStep(AM,  K6,   11);
	else if	((gFrequency>=1620000)   && (gFrequency<30000000))	SetModeFilterTuningStep(AM,  K6,    8);
	else if	((gFrequency>=30000000)  && (gFrequency<51000000))	SetModeFilterTuningStep(AM,  K6,    8);
	else if	((gFrequency>=51000000)  && (gFrequency<54000000))	SetModeFilterTuningStep(FM,  K15,  14);
	else if	((gFrequency>=54000000)  && (gFrequency<76000000))	SetModeFilterTuningStep(FM,  K15,   8);
	else if	((gFrequency>=76000000)  && (gFrequency<108000000))	SetModeFilterTuningStep(WFM, K230, 18);
	else if	((gFrequency>=108000000) && (gFrequency<136000000))	SetModeFilterTuningStep(AM,  K6,   15);
	else if	((gFrequency>=136000000) && (gFrequency<144000000))	SetModeFilterTuningStep(FM,  K15,  12);
	else if	((gFrequency>=144000000) && (gFrequency<146000000))	SetModeFilterTuningStep(FM,  K15,  14);
	else if	((gFrequency>=146000000) && (gFrequency<253000000))	SetModeFilterTuningStep(FM,  K15,  12);
	else if	((gFrequency>=253000000) && (gFrequency<255000000))	SetModeFilterTuningStep(FM,  K15,  13);
	else if	((gFrequency>=255000000) && (gFrequency<380000000))	SetModeFilterTuningStep(FM,  K15,  12);
	else if	((gFrequency>=380000000) && (gFrequency<382000000))	SetModeFilterTuningStep(FM,  K15,  13);
	else if	((gFrequency>=382000000) && (gFrequency<430000000))	SetModeFilterTuningStep(FM,  K15,  12);
	else if	((gFrequency>=430000000) && (gFrequency<440000000))	SetModeFilterTuningStep(FM,  K15,  14);
	else if	((gFrequency>=440000000) && (gFrequency<450000000))	SetModeFilterTuningStep(FM,  K15,  13);
	else if	((gFrequency>=450000000) && (gFrequency<850000000))	SetModeFilterTuningStep(FM,  K15,  13);
	else if	((gFrequency>=850000000) && (gFrequency<900000000))	SetModeFilterTuningStep(FM,  K15,  13);
	else if	((gFrequency>=900000000) && (gFrequency<=1300000000))	SetModeFilterTuningStep(FM,  K15,  13);
}

static void SetModeFilterTuningStep(UInt16 xMode, UInt16 xFilter, Int16 xTuningStep)
{
	SetMode(xMode);
	FrmSetControlGroupSelection(gFormP, 1, xMode);
	SetFilter(xFilter);
	FrmSetControlGroupSelection(gFormP, 2, xFilter);
	SetTuningStep(xTuningStep);
	LstSetSelection(GetObjectPtr(TuningStepList), xTuningStep);
	LstMakeItemVisible(GetObjectPtr(TuningStepList), xTuningStep);
	CtlSetLabel(GetObjectPtr(TuningStep), LstGetSelectionText(GetObjectPtr(TuningStepList), xTuningStep));
}

static void DisplayFrequencyDescription(Char* description)
{
	RectangleType		rectangle={0, 49, 128, 11};
	IndexedColorType	currentBackColor, currentTextColor, greenIndex=210, blackIndex=255;

	WinEraseRectangle(&rectangle, 0);

	if (StrLen(description)>0) {
					gOriginalFont=FntSetFont(stdFont);
					if (gSupportsColor) {
								currentBackColor=WinSetBackColor(greenIndex);
								currentTextColor=WinSetTextColor(blackIndex);
					}
					WinDrawChars(description, StrLen(description), 0, 49);
					if (gSupportsColor) {
								WinSetBackColor(currentBackColor);
								WinSetTextColor(currentTextColor);
					}
					FntSetFont(gOriginalFont);
	}
}

static void ReadMemoryFromMemoPad(void)
{
	DmOpenRef	memoDB;
	MemHandle	memoH;
	Char*		memoP;
	Char*		foundP;
	UInt16		memoRecordNumber=0;
	Int16		len, i=0, j=0, k=0;
	Char		memo[3000];
	Boolean		foundLineFeed=false;
	Boolean		foundSpace=false;
	Boolean		done=false;
	Char		tempString[11]="0000000000\0";
	Int32		tempFrequency;

	gNumberOfMemories=0;
	gMemoryIndex=0;

	memoDB=DmOpenDatabaseByTypeCreator('DATA', 'memo', dmModeReadOnly);
	if (memoDB==NULL) return;
	do {
		memoH=DmQueryRecord(memoDB, memoRecordNumber);
		if (memoH==NULL) break;
		memoP=MemHandleLock(memoH);
		if (memoP==NULL) break;
		foundP=StrStr(memoP, "IP1kC.c.Memory");
		if (foundP) {
			len=StrLen(memoP);
			if (len>2999) len=2999;
			StrNCopy(memo, memoP, len);
			memo[len]=chrNull;
			for (i=0; i<3000; i++) {
				if (gMemoryIndex==99) {		done=true;
								break;
				}
				if ((memo[i]==chrLineFeed) || (memo[i]==chrNull)) {
					foundLineFeed=true;
					foundSpace=false;
					tempFrequency=StrAToI(tempString);
					for (j=0; j<11; j++)
						tempString[j]=chrNull;
					if ((tempFrequency>=100000) && (tempFrequency<=1300000000)) {
						gMemory[gMemoryIndex]=tempFrequency;
						gMemoryDescription[gMemoryIndex][k]=chrNull;
						gMemoryMemoRecordNumber[gMemoryIndex]=memoRecordNumber;
						gMemoryIndex++;
					}
					else {
						for (k=0; k<26; k++)
							gMemoryDescription[gMemoryIndex][k]=chrNull;
					}
					j=0;
					k=0;
					if (memo[i]==chrLineFeed)	continue;
					if (memo[i]==chrNull)		break;
				}
				if ((memo[i]==chrSpace) && (!foundSpace)) {		foundSpace=true;
											foundLineFeed=false;
											continue;
				}
				if (foundLineFeed) {			tempString[j]=memo[i];
									if (j<9) j++;
				}
				if (foundSpace) {			gMemoryDescription[gMemoryIndex][k]=memo[i];
									if (k<25) k++;
				}
			}
		}
		MemHandleUnlock(memoH);
		if (done) break;
		memoRecordNumber++;
	}
	while (0==0);

	gNumberOfMemories=gMemoryIndex;
	gMemoryIndex=-1;

	DmCloseDatabase(memoDB);
}

static void ShowMemoryCounter(void)
{
	Char	temp1[3]="xx\0";
	Char	temp2[3]="xx\0";
	Char	temp3[18]="{Memory xx of xx}\0";

	if (gShowMemoryCounter) {
		StrIToA(temp1, gMemoryIndex+1);
		StrIToA(temp2, gNumberOfMemories);
		if (StrLen(temp1)==1) {			temp3[8]='0';
							temp3[9]=temp1[0];
		}
		else {					temp3[8]=temp1[0];
							temp3[9]=temp1[1];
		}
		if (StrLen(temp2)==1) {			temp3[14]='0';
							temp3[15]=temp2[0];
		}
		else {					temp3[14]=temp2[0];
							temp3[15]=temp2[1];
		}
		DisplayFrequencyDescription(temp3);
		SysTaskDelay(sysTicksPerSecond*3);
		DisplayFrequencyDescription(gMemoryDescription[gMemoryIndex]);
	}
}

static UInt32 StrHToI(const Char* string)
{
	UInt32	result=0;
	Char	c;

	c=*string++;
	if (!c) return 0;

	while(c) {
		if	((c>='0') && (c<='9'))	result=result*16+c-'0';
		else if	((c>='a') && (c<='f'))	result=result*16+c-'a'+10;
		else if	((c>='A') && (c<='F'))	result=result*16+c-'A'+10;
		else				break;

		c=*string++;
	}
	return result;
}

static void ExitApplication(void)
{
	EventType	newEvent;

	newEvent.eType=appStopEvent;
	EvtAddEventToQueue(&newEvent);
}
